#!/bin/sh
set -e

SCRIPT_DIR=$(realpath `dirname "$0"`)
cd $SCRIPT_DIR
. $SCRIPT_DIR/../download_boot_systems.sh

download_debian_11_if_needed
#download_sysrescuecd_if_needed

#UPDATE THOSE VARIABLES DEPENDING ON YOUR SITE
MY_IF_NAME=eth0
MY_IP_ADDR=192.168.46.2
DHCP_RANGE=192.168.46.100,static,255.255.255.0
ROUTER_ADDR=192.168.46.2
DNS_SERVER=1.1.1.1

#This is to make linux output visible in IPMI SOL. Remove if you are using a graphical card.
common=console=ttyS1,57600

mac='
00:22:4d:dd:64:da
'
i=0
hostname_prefix=munich-capri-

(
#echo set timeout=0
echo if false
echo then true
for mac in $mac; do
  echo "elif [ \$net_default_mac = $mac ]"
  echo then set i=`printf %03u $i`
  i=`expr $i + 1`
done
cat <<EOF
else unset timeout
fi

menuentry 'Install Debian' {
  linux /debian-installer/amd64/linux vga=788 url=tftp://\$pxe_default_server/preseed.cfg language=C country=FR keymap=fr hostname=${hostname_prefix}\$i domain= --- mitigations=off $common
  initrd /debian-installer/amd64/initrd.gz
}
menuentry 'SystemRescueCd' {
  linux /sysresccd/sysresccd/boot/x86_64/vmlinuz archisobasedir=sysresccd archiso_http_srv=http://\$pxe_default_server:69/sysresccd/ checksum ip=dhcp $common
  initrd /sysresccd/sysresccd/boot/intel_ucode.img /sysresccd/sysresccd/boot/amd_ucode.img /sysresccd/sysresccd/boot/x86_64/sysresccd.img
}
menuentry 'Exit' {
  exit
}
EOF
) >debian-installer/amd64/grub/grub.cfg


for mac in $mac
do
  hostname=${hostname_prefix}$(printf %03u $i)
  mkdir -p $hostname
  cat > $hostname/interfaces <<EOF
# This file describes the network interfaces available on your system
# and how to activate them. For more information, see interfaces(5).

source /etc/network/interfaces.d/*

# The loopback network interface
auto lo
iface lo inet loopback

# The primary network interface                                                 
allow-hotplug eno1                                                              
#iface eno1 inet dhcp                                                           
iface eno1 inet static                                                          
  address 192.168.179.$((212 + $i ))/24                                                  
  gateway 192.168.179.1                                                       
  dns-nameservers 80.80.80.80 80.80.81.81                                     
                                                                                
allow-hotplug enp193s0f1np1
iface enp193s0f1np1 inet dhcp

allow-hotplug enp193s0f1np0
iface enp193s0f1np0 inet dhcp
EOF
  i=`expr $i + 1`
done

# create authorized_keys if it doesn't exist
[ -f authorized_keys ] || ln -s ../authorized_keys
exec dnsmasq -d --port=0 --log-dhcp \
  --interface=$MY_IF_NAME \
  --bind-interfaces \
  --except-interface=lo \
  --listen-address=$MY_IP_ADDR \
  --dhcp-range=$DHCP_RANGE \
  --dhcp-option=option:router,$ROUTER_ADDR \
  --dhcp-option=option:dns-server,$DNS_SERVER \
  --dhcp-boot=debian-installer/amd64/grubx64.efi \
  --enable-tftp --tftp-root=$SCRIPT_DIR \
  --conf-file=/dev/null \
  --dhcp-host=00:22:4D:DD:64:DA,192.168.46.51,1h \
  --dhcp-host=00:22:4D:DD:64:DB,192.168.46.101,1h \

